#pragma once

#include "sogoulib_def.h"

class ISogouUnknown
{
public:
	virtual int AddRef() = 0;
	virtual int Release() = 0;
};

//ѡԪ
class ISogouCoreResultElement : public ISogouUnknown
{
public:
	virtual const char* Word() const = 0;  //<ѡ
	virtual int WordLength() const = 0; //<WordӦֵĸ
	virtual int MatchInputLength() const = 0;	//<ѡӦ볤
	virtual int MatchWordLength() const = 0;	//<ƥ봮ĺѡȣʱܺѡ봮
	virtual int SubMatchInputLength(int nIndex) const = 0; //<ѡеnIndexֶӦ볤
	virtual const char* WordShow() const = 0; //<for show
	virtual bool CutOff(int nIdxStart) = 0; //<delete from nIdxStart(by word)
	virtual char *GetSPHint() = 0; //free after use
};

//ѧʵĶ
class ISogouCoreWordBuffer : public ISogouCoreResultElement
{
public:
	virtual bool Append(ISogouCoreResultElement* pElement) = 0; //<ƴӶѡ
	virtual void Reset() = 0; //<ս
	virtual void Back() = 0; //<backspaceһѡ
};

class ISogouCoreResult : public ISogouUnknown
{
public:
	virtual int Count() const = 0;
	virtual ISogouCoreResultElement* Element(int nIndex) = 0;
};

class ISogouCoreCloudHelper
{
public:
	virtual int GetRequestIdx() const = 0;
	virtual void AddCand(ISogouCoreResultElement *p_pCandItem) = 0;
};

class ISogouCoreEngine : public ISogouUnknown
{
public:
	virtual bool Init(const char* szVersion, const char* szBuildTime) = 0;
	virtual bool LoadDict(const char* szSys, const char* szUser) = 0;
	virtual ISogouCoreResult* DoConvert(const char* szComp, int nRequestIdx, bool *pbNeedCloud, bool bHalfSelect) = 0;
	virtual bool LearnWord(ISogouCoreWordBuffer* pWord) = 0;
	virtual bool SaveUserDict() = 0;
	virtual ISogouCoreWordBuffer* CreateWordBuffer() = 0;
	virtual bool InitCloud(ISogouCoreCloudHelper *p_pHelper) = 0;
	virtual bool ReloadConfig() = 0;
	virtual bool LearnEnglish(const char *szComp) = 0;
	virtual ISogouCoreResultElement* CreatePysResultElement(const char *szComp) = 0;
	virtual bool ReloadDict() = 0;
};

extern "C" {
ISogouCoreEngine* GetSogouCoreEngine();
}
